using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Diagnostics;

namespace Tutorial_4_5
{
    class Circle2D
    {
        private float m_center_x;
        private float m_center_y;
        private float m_radius;

        public Circle2D()
        {
            m_center_x = 0;
            m_center_y = 0;
            m_radius = 0;
        }

        public void SetCenter(float x, float y)
        {
            m_center_x = x;
            m_center_y = y;
        }

        public void SetRadius(float radius)
        {
            m_radius = radius;
        }

        public void Draw(GraphicsDevice device)
        {
            Debug.Assert(device != null, "device not valid on Circle2D draw call");
            if (m_radius > 0)
            {
                const int kNumPts = 100;
                DeviceVertexFormat[] v = new DeviceVertexFormat[kNumPts + 2];

                float theta = (float)((2.0f * 3.14159265f) / kNumPts);

                v[0].Position = new Vector3(m_center_x, m_center_y, 0f);
                v[0].Color = new Color(new Vector4(.4f, .4f, .4f, 1f));

                for (int i = 0; i < (kNumPts); i++)
                {
                    float X = m_center_x + (m_radius * (float)Math.Cos(i * theta));
                    float Y = m_center_y + (m_radius * (float)Math.Sin(i * theta));
                    v[i + 1].Position = new Vector3(X, Y, 0f);
                    v[i + 1].Color = v[0].Color;
                }
                v[kNumPts + 1] = v[1];

                device.DrawUserPrimitives(PrimitiveType.TriangleFan, v, 0, kNumPts);
            }
        }
    }
}
