using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using UWBGL_WinForms_Lib1;
using UWBGL_XNA_Lib3;

namespace XNA_BallShoot
{
    class DrawOnlyHandler : UWB_XNAWindowHandler
    {
        private UWBGL_UIWindow mWindow;

        public DrawOnlyHandler()
        {
            mWindow = new UWBGL_UIWindow(true);
        }

        public bool Initialize(Control PlaceHolder)
        {
            if (!mWindow.ReplaceFormControl(PlaceHolder.Handle))
                return false;

            if (!mWindow.AttachHandler(this))
                return false;
            
            return true;
        }

        public override void DrawGraphics()
        {
            float height = 0;
            float width = 0;
            Program.getModel().getWorldSize(ref width, ref height);
            width = height * getAspectRatio();

            Matrix World2NDC = new Matrix();
            Vector3 scale = new Vector3(2f / width, 2f / height, 1f);
            Vector3 translate = new Vector3(-1f, -1f, 0f);
            World2NDC = Matrix.CreateScale(scale) * Matrix.CreateTranslation(translate);

            UWB_XNAGraphicsSystem.m_TheAPI.setViewMatrix(World2NDC);

            BeginScene();

            Program.getModel().drawModel();

            EndSceneAndShow();
        }
    }
}
