using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace UWBGL_XNA_Lib4
{
    public class UWB_CircleGeom
    {
		protected Vector3 mCenter;
		protected float mRadius;
		protected Color mColor;
		protected Color mShadingColor;
		protected eFillMode mFillMode;
		protected eShadeMode mShadeMode;

		public UWB_CircleGeom()
		{
			mCenter = Vector3.Zero;
			mRadius = 0;
			mFillMode = eFillMode.fmSolid;
			mShadeMode = eShadeMode.smFlat;
			mShadingColor = Color.Black;
		}

		public void setCenter(float x, float y, float z)
		{
			mCenter.X = x;
			mCenter.Y = y;
			mCenter.Z = z;
		}

		public void setCenter(Vector3 center)
		{
			mCenter.X = center.X;
			mCenter.Y = center.Y;
			mCenter.Z = center.Z;
		}

		public Vector3 getCenter()
		{
			return mCenter;
		}

		public void setRadius(float radius)
		{
			mRadius = radius;
		}

		public float getRadius()
		{
			return mRadius;
		}

		public void setColor(Color color)
		{
			mColor = color;
		}

		public Color getColor()
		{
			return mColor;
		}

		public void setShadingColor(Color shadingColor)
		{
			mShadingColor = shadingColor;
		}

		public Color getShadingColor()
		{
			return mShadingColor;
		}

		public void setFillMode(eFillMode fillMode)
		{
			mFillMode = fillMode;
		}

		public eFillMode getFillMode()
		{
			return mFillMode;
		}

		public void setShadeMode(eShadeMode shadeMode)
		{
			mShadeMode = shadeMode;
		}

		public eShadeMode getShadeMode()
		{
			return mShadeMode;
		}

		public void draw(UWB_DrawHelper drawHelper)
		{
			if (drawHelper != null)
			{
				drawHelper.resetAttributes();
				drawHelper.setFillMode(mFillMode);
				drawHelper.setShadeMode(mShadeMode);
				drawHelper.setColor1(mColor);
				drawHelper.setColor2(mShadingColor);
				drawHelper.drawCircle(mCenter, mRadius);
			}
		}
    }
}
